<% local view, viewlibrary, page_info, session = ... 
require("viewfunctions")
%>

<% -- Pregenerate the list of users
if viewlibrary.check_permission("listusers") and (viewlibrary.check_permission("forwardmessage") or viewlibrary.check_permission("forwardmymessage")) then
	local users = viewlibrary.dispatch_component("listusers", nil, true)
	useroptions = {"<option></option>"}
	table.sort(users.value, function(a,b) if a.firstname ~= b.firstname then return a.firstname < b.firstname elseif a.lastname ~= b.lastname then return a.lastname < b.lastname else return a.username < b.username end end)
	for i,u in ipairs(users.value) do
		if u.username ~= session.userinfo.userid then
			useroptions[#useroptions+1] = '<option value="'..html.html_escape(u.username)..'">'..html.html_escape(u.firstname)..' '..html.html_escape(u.lastname)..' ('..html.html_escape(u.username)..')</option>'
		end
	end
	useroptions = table.concat(useroptions)
end
%>
<% -- Pregenerate the list of folders
reversefolders = {}
if viewlibrary.check_permission("listfolders") then
	local folders = viewlibrary.dispatch_component("listfolders", nil, true)
	for i,u in ipairs(folders.value) do
		reversefolders[u.in_folder] = u.label
	end
	if (viewlibrary.check_permission("movemessage") or viewlibrary.check_permission("movemymessage")) then
		if #folders.value <= 1 then
			dontmove = true
		end
		folderoptions = {"<option></option>"}
		for i,u in ipairs(folders.value) do
			folderoptions[#folderoptions+1] = '<option value="'..html.html_escape(u.in_folder)..'">'..html.html_escape(u.label)..'</option>'
		end
		folderoptions = table.concat(folderoptions)
	end
end
%>
<% -- Figure out the callback number
callmenumber = nil
if viewlibrary.check_permission("editmyusersettings") and viewlibrary.check_permission("callbackmymessage") then
	local settings = viewlibrary.dispatch_component("editmyusersettings", nil, true)
	if settings and settings.value and settings.value.callmenumber then
		callmenumber = settings.value.callmenumber.value
	end
end
%>

<script type="text/javascript" src="<%= html.html_escape(page_info.wwwprefix) %>/js/jquery-latest.js"></script>
<script type="text/javascript" src="<%= html.html_escape(page_info.wwwprefix) %>/js/jquery.tablesorter.js"></script>
<script type="text/javascript">
	function PlayMessage() {
		$(".temporaryplayer").remove();
		$(this).parent().parent().after("<tr class='temporaryplayer'><td colspan='9'><embed width='100%' height='25px' autostart='1' playcount='1' src='" + $(this).attr("href") + "' type='application/x-mplayer2'></embed></TD></TR>");
		return false;
	}
	function HandleMulti() {
		var messages = [];
		$(".multicheck:checked").each(function(){
			messages[messages.length] = this.value;
		});
		$(this).parent().find("[name='message']").attr("value", messages.join(","));
	}
        $(document).ready(function() {
                $("#list").tablesorter({headers: {0:{sorter: false}, 1:{sorter: false}}});
		$("#list").bind("sortStart",function() {
			$(".temporaryplayer").remove();
		});
		$(".playmessage").click(PlayMessage);
<% if viewlibrary.check_permission("deletemessage") or viewlibrary.check_permission("deletemymessage") then %>
		$("#multidelete").click(HandleMulti);
<% end %>
<% if viewlibrary.check_permission("forwardmessage") or viewlibrary.check_permission("forwardmymessage") then %>
		$("#multiforward").click(HandleMulti);
<% end %>
<% if viewlibrary.check_permission("emailmessage") or viewlibrary.check_permission("emailmymessage") then %>
		$("#multiemail").click(HandleMulti);
<% end %>
<% if viewlibrary.check_permission("movemessage") or viewlibrary.check_permission("movemymessage") then %>
		$("#multimove").click(HandleMulti);
<% end %>
        });
</script>

<% displaycommandresults({"deletemessage", "deletemymessage", "forwardmessage", "forwardmymessage", "emailmessage", "emailmymessage", "movemessage", "movemymessage", "callbackmessage", "callbackmymessage"}, session) %>

<h1>Messages</h1>
<DL>
<TABLE><TR><TD>
<% if viewlibrary.check_permission("deletemessage") or viewlibrary.check_permission("deletemymessage") then %>
	<form id="multidelete" action="<%= html.html_escape(page_info.script..page_info.prefix..page_info.controller) %>/
		<% if viewlibrary.check_permission("deletemessage") then io.write("deletemessage") else io.write("deletemymessage") end %>
		" method="POST">
	<input class="hidden" type="hidden" name="redir"  value="<%= html.html_escape(page_info.orig_action) %>" >
	<input class="hidden" type="hidden" name="message"  value="" >
	<input class="submit" type="submit" value="Delete">
	</form>
<% end %>
<% if viewlibrary.check_permission("forwardmessage") or viewlibrary.check_permission("forwardmymessage") then %>
	<form id="multiforward" action="<%= html.html_escape(page_info.script .. page_info.prefix .. page_info.controller) %>/
		<% if viewlibrary.check_permission("forwardmessage") then io.write("forwardmessage") else io.write("forwardmymessage") end %>
		" method="POST">
	<input class="hidden" type="hidden" name="redir"  value="<%= html.html_escape(page_info.orig_action) %>" >
	<input class="hidden" type="hidden" name="message"  value="" >
	<input class="submit" type="submit" value="Forward">
	<select name="newuser" style="width:auto;"><%= (useroptions or "") %></select>
	</form>
<% end %>
<% if viewlibrary.check_permission("emailmessage") or viewlibrary.check_permission("emailmymessage") then %>
	<form id="multiemail" action="<%= html.html_escape(page_info.script .. page_info.prefix .. page_info.controller) %>/
		<% if viewlibrary.check_permission("emailmessage") then io.write("emailmessage") else io.write("emailmymessage") end %>
		" method="POST">
	<input class="hidden" type="hidden" name="redir"  value="<%= html.html_escape(page_info.orig_action) %>" >
	<input class="hidden" type="hidden" name="message"  value="" >
	<input class="submit" type="submit" value="E-mail">
	<input class="text" type="text" name="address"  value="" style="width:auto;">
	</form>
<% end %>
<% if viewlibrary.check_permission("movemessage") or viewlibrary.check_permission("movemymessage") then %>
	<% if not dontmove then %>
		<form id="multimove" action="<%= html.html_escape(page_info.script .. page_info.prefix .. page_info.controller) %>/
			<% if viewlibrary.check_permission("movemessage") then io.write("movemessage") else io.write("movemymessage") end %>
			" method="POST">
		<input class="hidden" type="hidden" name="redir"  value="<%= html.html_escape(page_info.orig_action) %>" >
		<input class="hidden" type="hidden" name="message"  value="" >
		<input class="submit" type="submit" value="Move">
		<select name="newfolder" style="width:auto;"><%= (folderoptions or "") %></select>
		</form>
	<% end %>
<% end %>
</TD></TR></TABLE>
<table><tr><td>
<small>select: </small>
<small><a href='' OnClick='$(".multicheck").attr("checked", "true"); return false;'>all</a></small>
<small><a href='' OnClick='$(".multicheck").removeAttr("checked"); return false;'>none</a></small>
</td></tr></table>

<TABLE id="list" class="tablesorter"><THEAD>
	<TR style="background:#eee;font-weight:bold;">
		<TH></TH>
		<TH>Action</TH>
		<TH>Date</TH>
		<TH>Time</TH>
		<TH>Caller ID</TH>
		<TH>Priority</TH>
		<TH>Orig Mailbox</TH>
		<TH>Folder</TH>
		<TH>Duration</TH>
	</TR>		
</THEAD><TBODY>
<% for k,v in ipairs( view.value ) do %>
	<TR>
		<TD><input type=checkbox class="multicheck" value="<%= html.html_escape(v.uuid) %>"></TD>
		<TD>
		<% if viewlibrary.check_permission("downloadmessage") then %>
			<%= html.link{value=page_info.script..page_info.prefix..page_info.controller.."/downloadmessage?message="..v.uuid, label="Download "} %>
			<%= html.link{value=page_info.script..page_info.prefix..page_info.controller.."/downloadmessage?message="..v.uuid, class="playmessage", label="Play "} %>
		<% elseif viewlibrary.check_permission("downloadmymessage") then %>
			<%= html.link{value=page_info.script..page_info.prefix..page_info.controller.."/downloadmymessage?message="..v.uuid, label="Download "} %>
			<%= html.link{value=page_info.script..page_info.prefix..page_info.controller.."/downloadmymessage?message="..v.uuid, class="playmessage", label="Play "} %>
		<% end %>
		<% if callmenumber then %>
			<%= html.link{value=page_info.script..page_info.prefix..page_info.controller.."/callbackmymessage?message="..v.uuid.."&extension="..callmenumber, label="Callback "} %>
		<% end %>
		</TD>
                <TD><%= html.html_escape(os.date("%x", v.created_epoch)) %></TD>
                <TD><%= html.html_escape(os.date("%X", v.created_epoch)) %></TD>
                <TD><%= html.html_escape(v.cid_number) %></TD>
                <TD><%= html.html_escape(v.read_flags) %></TD>
                <TD><%= html.html_escape(v.username) %></TD>
                <TD><%= html.html_escape(reversefolders[v.in_folder] or v.in_folder) %></TD>
                <TD><%= html.html_escape(v.message_len) %></TD>
	</TR>
<% end %>
</TBODY>
</TABLE>

<% if view.errtxt then %>
<p class="error"><%= html.html_escape(view.errtxt) %></p>
<% end %>
<% if #view.value == 0 then %>
<p>No messages found</p>
<% end %>

</DL>
